diff --git a/src/rrd2json.c b/src/rrd2json.c
index c7a46982bb834..34e1535dd582d 100644
--- a/src/rrd2json.c
+++ b/src/rrd2json.c
@@ -124,6 +124,43 @@ void rrd_stats_api_v1_charts(BUFFER *wb)
     );
 }
 
+void rrd_stats_api_v1_charts_allmetrics_prometheus(BUFFER *wb)
+{
+    pthread_rwlock_rdlock(&localhost.rrdset_root_rwlock);
+
+    // for each chart
+    RRDSET *st;
+    for(st = localhost.rrdset_root; st ; st = st->next) {
+        buffer_strcat(wb, "\n");
+        if(st->enabled && st->dimensions) {
+            // for each dimension
+            RRDDIM *rd;
+            for(rd = st->dimensions; rd ; rd = rd->next) {
+                if(rd->counter) {
+                    buffer_sprintf(wb, "# HELP %s.%s %s\n", st->id, rd->id, st->units);
+
+                    switch(rd->algorithm) {
+                        case RRDDIM_INCREMENTAL:
+                        case RRDDIM_PCENT_OVER_DIFF_TOTAL:
+                            buffer_sprintf(wb, "# TYPE %s.%s counter\n", st->id, rd->id);
+                            break;
+
+                        default:
+                            buffer_sprintf(wb, "# TYPE %s.%s gauge\n", st->id, rd->id);
+                            break;
+                    }
+
+                    calculated_number n = (calculated_number)rd->last_collected_value * (calculated_number)(abs(rd->multiplier)) / (calculated_number)(abs(rd->divisor));
+
+                    buffer_sprintf(wb, "%s.%s " CALCULATED_NUMBER_FORMAT " %llu\n", st->id, rd->id, n,
+                            (unsigned long long)((rd->last_collected_time.tv_sec * 1000) + (rd->last_collected_time.tv_usec / 1000)));
+                }
+            }
+        }
+    }
+
+    pthread_rwlock_unlock(&localhost.rrdset_root_rwlock);
+}
 
 unsigned long rrd_stats_one_json(RRDSET *st, char *options, BUFFER *wb)
 {
diff --git a/src/rrd2json.h b/src/rrd2json.h
index d3dc44e0a38d6..7a34b15051aee 100644
--- a/src/rrd2json.h
+++ b/src/rrd2json.h
@@ -32,6 +32,12 @@ extern char *hostname;
 #define DATASOURCE_FORMAT_SSV_COMMA "ssvcomma"
 #define DATASOURCE_FORMAT_CSV_JSON_ARRAY "csvjsonarray"
 
+#define RAWMETRICS_FORMAT_BASH "bash"
+#define RAWMETRICS_FORMAT_PROMETHEUS "prometheus"
+
+#define RAWMETRICS_BASH 1
+#define RAWMETRICS_PROMETHEUS 2
+
 #define GROUP_UNDEFINED         0
 #define GROUP_AVERAGE           1
 #define GROUP_MIN               2
@@ -56,6 +62,9 @@ extern char *hostname;
 extern void rrd_stats_api_v1_chart(RRDSET *st, BUFFER *wb);
 extern void rrd_stats_api_v1_charts(BUFFER *wb);
 
+// extern void rrd_stats_api_v1_charts_allmetrics_bash(BUFFER *wb);
+extern void rrd_stats_api_v1_charts_allmetrics_prometheus(BUFFER *wb);
+
 extern unsigned long rrd_stats_one_json(RRDSET *st, char *options, BUFFER *wb);
 
 extern void rrd_stats_graph_json(RRDSET *st, char *options, BUFFER *wb);
diff --git a/src/web_client.c b/src/web_client.c
index db9903f8732fb..161f7a08370c9 100644
--- a/src/web_client.c
+++ b/src/web_client.c
@@ -774,6 +774,45 @@ int web_client_api_request_v1_charts(struct web_client *w, char *url)
     return 200;
 }
 
+int web_client_api_request_v1_allmetrics(struct web_client *w, char *url)
+{
+    int format = 0;
+
+    while(url) {
+        char *value = mystrsep(&url, "?&");
+        if (!value || !*value) continue;
+
+        char *name = mystrsep(&value, "=");
+        if(!name || !*name) continue;
+        if(!value || !*value) continue;
+
+        if(!strcmp(name, "format")) {
+            if(!strcmp(value, RAWMETRICS_FORMAT_BASH))
+                format = RAWMETRICS_BASH;
+            else if(!strcmp(value, RAWMETRICS_FORMAT_PROMETHEUS))
+                format = RAWMETRICS_PROMETHEUS;
+        }
+    }
+
+    buffer_flush(w->response.data);
+    buffer_no_cacheable(w->response.data);
+    w->response.data->contenttype = CT_TEXT_PLAIN;
+
+    switch(format) {
+        //case RAWMETRICS_BASH:
+        //    rrd_stats_api_v1_charts_allmetrics_bash(w->response.data);
+        //    return 200;
+
+        case RAWMETRICS_PROMETHEUS:
+            rrd_stats_api_v1_charts_allmetrics_prometheus(w->response.data);
+            return 200;
+
+        default:
+            buffer_strcat(w->response.data, "Which format? Only '" RAWMETRICS_FORMAT_PROMETHEUS "' is currently supported.");
+            return 400;
+    }
+}
+
 int web_client_api_request_v1_chart(struct web_client *w, char *url)
 {
     return web_client_api_request_single_chart(w, url, rrd_stats_api_v1_chart);
@@ -1377,7 +1416,7 @@ int web_client_api_request_v1_registry(struct web_client *w, char *url)
 }
 
 int web_client_api_request_v1(struct web_client *w, char *url) {
-    static uint32_t hash_data = 0, hash_chart = 0, hash_charts = 0, hash_registry = 0, hash_badge = 0, hash_alarms = 0, hash_alarm_log = 0, hash_alarm_variables = 0;
+    static uint32_t hash_data = 0, hash_chart = 0, hash_charts = 0, hash_registry = 0, hash_badge = 0, hash_alarms = 0, hash_alarm_log = 0, hash_alarm_variables = 0, hash_raw = 0;
 
     if(unlikely(hash_data == 0)) {
         hash_data = simple_hash("data");
@@ -1388,6 +1427,7 @@ int web_client_api_request_v1(struct web_client *w, char *url) {
         hash_alarms = simple_hash("alarms");
         hash_alarm_log = simple_hash("alarm_log");
         hash_alarm_variables = simple_hash("alarm_variables");
+        hash_raw = simple_hash("allmetrics");
     }
 
     // get the command
@@ -1420,6 +1460,9 @@ int web_client_api_request_v1(struct web_client *w, char *url) {
         else if(hash == hash_alarm_variables && !strcmp(tok, "alarm_variables"))
             return web_client_api_request_v1_alarm_variables(w, url);
 
+        else if(hash == hash_raw && !strcmp(tok, "allmetrics"))
+            return web_client_api_request_v1_allmetrics(w, url);
+
         else {
             buffer_flush(w->response.data);
             buffer_strcat(w->response.data, "Unsupported v1 API command: ");
